﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;
using System.IO;
using System.Drawing;

namespace WpfPost11431
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Random ra = new Random();

            List<ChartDataClass> chartDatas = new List<ChartDataClass>();

            for (int i = 0; i < 10; i++)
            {
                ChartDataClass cdc = new ChartDataClass();
                cdc.XValue=i;
                cdc.YValue = ra.NextDouble() * 100;

                chartDatas.Add(cdc);
            }
            chart.Series[0].ItemsSource = chartDatas;

            FileStream stream = new FileStream(@"E:\Work1307\WpfPost11431\App_Data\table.png", FileMode.OpenOrCreate);
            Telerik.Windows.Media.Imaging.ExportExtensions.ExportToImage(chart, stream, new PngBitmapEncoder());

            wpfMap1.MapUnit = GeographyUnit.DecimalDegree;
            ShapeFileFeatureLayer usStates = new ShapeFileFeatureLayer(@"..\..\..\App_Data\USStates.shp");
            usStates.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.State1;
            usStates.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            usStates.Open();
            wpfMap1.CurrentExtent = usStates.GetBoundingBox();
            usStates.Close();

            ZedGraphStyle zedGraphStyle = new ZedGraphStyle();
            zedGraphStyle.ZedGraphDrawing += new EventHandler<ZedGraphDrawingEventArgs>(zedGraphStyle_ZedGraphDrawing);

            InMemoryFeatureLayer inmemoryLayer = new InMemoryFeatureLayer();
            inmemoryLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(zedGraphStyle);
            inmemoryLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            inmemoryLayer.InternalFeatures.Add(new Feature(new PointShape(-20.11978175, 100.376652)));

            LayerOverlay usOverlay = new LayerOverlay();
            usOverlay.Layers.Add(usStates);
            usOverlay.Layers.Add(inmemoryLayer);
            wpfMap1.Overlays.Add(usOverlay);

            wpfMap1.Refresh();
        }

        void zedGraphStyle_ZedGraphDrawing(object sender, ZedGraphDrawingEventArgs e)
        {
            Bitmap bitmap = new Bitmap(@"..\..\..\App_Data\table.png");
            e.Bitmap = bitmap;
        }
    }

    public class ChartDataClass
    {
        public double XValue { get; set; }
        public double YValue { get; set; }

        public ChartDataClass()
        { }
    }
}
